import logging
import event
import time
import libvirt

def eventToString(event):
    eventStrings = ( "Defined",
                     "Undefined",
                     "Started",
                     "Suspended",
                     "Resumed",
                     "Stopped",
                     "Shutdown"
                   )
    try:
        return eventStrings[event]
    except IndexError:
        return "Unknown (%d)" % event

def detailToString(event, detail):
    eventStrings = (
        ( "Added", "Updated" ), # Defined
        ( "Removed", ), # Undefined
        ( "Booted", "Migrated", "Restored", "Snapshot", "Wakeup" ), # Started
        ( "Paused", "Migrated", "IOError", "Watchdog", "Restored", "Snapshot" ), # Suspended
        ( "Unpaused", "Migrated", "Snapshot" ), # Resumed
        ( "Shutdown", "Destroyed", "Crashed", "Migrated", "Saved", "Failed", "Snapshot" ), # Stopped
        ( "Finished", ), # Shutdown
        )
    try:
        return eventStrings[event][detail]
    except IndexError:
        return "Unknown (%d)" % detail

def changed(conn, dom, event, detail, opaque):
    print "EVENT: Domain %s(%s) %s %s" % (dom.name(), dom.ID(), eventToString(event), detailToString(event, detail))

l = logging.getLogger()
#l.setLevel(logging.DEBUG)
sh = logging.StreamHandler()
l.addHandler(sh)


event.virEventLoopPureStart(l)
v = libvirt.openReadOnly("")
v.domainEventRegister(changed, None)

while True:
    time.sleep(1)
